/***************************************************************/
//
//
//		DirectX	[ filemanager.h ]
//
//											Author	kazuki tanaka
//											Date	2017 6/1
/*---------------------------------------------------------------
Update : 2017/6/1
			Create Header File -> filemanager.h.h 
 			< Add Class Function >
				FILEMANAGER->Constructor
				FILEMANAGER->Destructor
				FILEMANAGER->Create ( static member )
				FILEMANAGER->Init
				FILEMANAGER->Uninit
				FILEMANAGER->Update
				FILEMANAGER->Draw

Update : 2017/6/1



/*-------------------------------------------------------------*/
#ifndef _FILEMANAGER_H_

#define _FILEMANAGER_H_

/*---------------------------------------------------------------
	Class
---------------------------------------------------------------*/


// Class FileManager Using FileManager
class FileManager
{
public:
	
	FileManager( );							// FileManager Constructor
	~FileManager( );						// FileManager Destructor

	static FileManager* Create( void );		// FileManager Create Instance Class

	void Init( void );						// FileManager Initialize
	void Uninit( void );					// FileManager Uninitialize
	void Update( void );					// FileManager Update
	void Draw( void );						// FileManager Draw

	static char* LoadFileCharData(			// FileManager GetCharData
		const char* filename );	


private:

	// Member Variable
	static FileManager* pManager;

};


#endif	//	_FILEMANAGER_H_


