/***************************************************************/
//
//
//		DirectX	[ gllight.h ]
//
//											Author	kazuki tanaka
//											Date	2017 5/16
/*---------------------------------------------------------------
Update : 2017/5/16
			Create Header File -> gllight.h.h 
 			< Add Class Function >
				CGLLIGHT->Constructor
				CGLLIGHT->Destructor
				CGLLIGHT->Create ( static member )
				CGLLIGHT->Init
				CGLLIGHT->Uninit
				CGLLIGHT->Update
				CGLLIGHT->Draw

Update : 2017/5/16



/*-------------------------------------------------------------*/
#ifndef _GLLIGHT_H_

#define _GLLIGHT_H_



#include "color.h"
#include "vector3.h"

/*---------------------------------------------------------------
	class
---------------------------------------------------------------*/


// class GLLight Using GLLight
class GLLight
{
public:
	
	Color diffuse;
	Color ambient;
	Color specular;
	Vector3 pos;
	
public:
	GLLight( );						// GLLight constructor
	~GLLight( );					// GLLight destructor

	static GLLight* Create( void );	// GLLight Create Instance Class

	void Init( void );				// GLLight Initialize
	void Uninit( void );			// GLLight Uninitialize
	void Update( void );			// GLLight Update
	void Draw( void );				// GLLight Draw



private:

	// Member Function


};


#endif	//	_GLLIGHT_H_


