/***************************************************************/
//
//
//		DirectX	[ mesh3dobjectdx9.h ]
//
//											Author	kazuki tanaka
//											Date	2017 5/25
/*---------------------------------------------------------------
Update : 2017/5/25
			Create Header File -> mesh3dobjectdx9.h.h 
 			< Add Class Function >
				MESH3DOBJECTDX9->Constructor
				MESH3DOBJECTDX9->Destructor
				MESH3DOBJECTDX9->Create ( static member )
				MESH3DOBJECTDX9->Init
				MESH3DOBJECTDX9->Uninit
				MESH3DOBJECTDX9->Update
				MESH3DOBJECTDX9->Draw

Update : 2017/5/25



/*-------------------------------------------------------------*/
#ifndef _MESH3DOBJECTDX9_H_

#define _MESH3DOBJECTDX9_H_



/*---------------------------------------------------------------
	Include
---------------------------------------------------------------*/

#include "mesh3dobject.h"

#include "rendererdx9.h"


class TextureInterface;

/*---------------------------------------------------------------
	Class
---------------------------------------------------------------*/


// Class Mesh3DObjectDX9 Using Mesh3DObjectDX9
class Mesh3DObjectDX9 : public Mesh3DObject
{
public:
	
	Mesh3DObjectDX9( );						// Mesh3DObjectDX9 Constructor
	~Mesh3DObjectDX9( );					// Mesh3DObjectDX9 Destructor

	static Mesh3DObjectDX9* Create( void );	// Mesh3DObjectDX9 Create Instance Class

	void Release( void );					// Mesh3DObjectDX9 Uninitialize
	bool Load( 								// Mesh3DObjectDX9 Load
		const char* FILE_NAME );

	LPD3DXMESH GetMesh( void );				// Mesh3DObjectDX9 GetMesh
	LPD3DXBUFFER GetMatBuffer( void );		// Mesh3DObjectDX9 GetMaterialBuffer
	DWORD GetMatNumber( void );				// Mesh3DObjectDX9 GetMatNumber
	TextureInterface* GetTexture(			// Mesh3DObjectDX9 GetTexture
		const int& index );

private:

	// Member Variable
	LPD3DXMESH   pMesh;						// MeshInterfacePointer
	LPD3DXBUFFER pBufMat;					// MaterialInfo
	DWORD        matNum;					// MaterialNumber
	
	TextureInterface** ppTexture;			// TexutureInterface


};


#endif	//	_MESH3DOBJECTDX9_H_


