/***************************************************************/
//
//
//		DirectX	[ renderingorder.h ]
//
//											Author	kazuki tanaka
//											Date	2017 5/24
/*---------------------------------------------------------------
Update : 2017/5/24
			Create Header File -> renderingorder.h.h 
 			< Add Class Function >
				RENDERINGORDER->Constructor
				RENDERINGORDER->Destructor
				RENDERINGORDER->Create ( static member )
				RENDERINGORDER->Init
				RENDERINGORDER->Uninit
				RENDERINGORDER->Update
				RENDERINGORDER->Draw

Update : 2017/5/24



/*-------------------------------------------------------------*/
#ifndef _RENDERINGORDER_H_

#define _RENDERINGORDER_H_


/*---------------------------------------------------------------
	Include File
---------------------------------------------------------------*/

class VertexBuffer;
class IndexBuffer;
class Mesh3DObject;
class TextureInterface;
class Matrix;

/*---------------------------------------------------------------
	Class
---------------------------------------------------------------*/


// Class RenderingOrder Using RenderingOrder
class RenderingOrder
{
public:
	
	RenderingOrder( );								// RenderingOrder Constructor
	virtual ~RenderingOrder( );						// RenderingOrder Destructor

	virtual void DrawPrimitiveStrip(				// RenderingOrder DrawPrimitive
		VertexBuffer* pVtxBuf,
		TextureInterface* pTexture = nullptr,
		Matrix* mtx = nullptr );
	virtual void DrawPrimitiveList(					// RenderingOrder DrawPrimitive
		VertexBuffer* pVtxBuf,
		TextureInterface* pTexture = nullptr,
		Matrix* mtx = nullptr );
	virtual void DrawPrimitiveFan(					// RenderingOrder DrawPrimitive
		VertexBuffer* pVtxBuf,
		TextureInterface* pTexture = nullptr,
		Matrix* mtx = nullptr );
	virtual void DrawSubset( 						// RenderingOrder DrawSubset
		Mesh3DObject* pMeshObj,
		Matrix* mtx = nullptr );		
	
	virtual void DrawIndexPrimitive( 				// RenderingOrder DrawIndexPrimitive
		VertexBuffer* pVtxBuf,
		IndexBuffer* pIdxBuf,
		TextureInterface* pTexture = nullptr,
		Matrix* mtx = nullptr );

	static inline RenderingOrder* Operate( void ){	// Rendering Order 
		return pOrder; }		

	static void Release( void );					// RenderingOrder Release


private:

	// Member Variable
	static RenderingOrder* pOrder;

};


#endif	//	_RENDERINGORDER_H_


