/***************************************************************/
//
//
//		DirectX	[ sample.cpp ]
//
//											Author	kazuki tanaka
//											Date	2017 5/25
/*---------------------------------------------------------------
Update : 2017/5/25
			sample.cpp̍쐬

/*---------------------------------------------------------------
	Include File
---------------------------------------------------------------*/

#include "sample.h"

#include "mesh_renderer3d.h"
#include "mesh3dobjectdx9.h"

#include <math.h>

#include "keyboard.h"

/*---------------------------------------------------------------
	Macro Difinition
---------------------------------------------------------------*/


/*---------------------------------------------------------------
	Const Number Difinition
---------------------------------------------------------------*/


/*----------------------------------------------------------------
	static member variable Initialize 
----------------------------------------------------------------*/





// CSample Constructor
CSample::CSample( )
	: renderer(nullptr)
	, pMesh(nullptr)
	, pos( Vector3( 0, 0, 0 ))
	, world( Matrix( ) )
{

	// Menber Clear Process

}

// CSample Destructor
CSample::~CSample( )
{

	// Do Nothing!!

}

// CSample Create Instance 
CSample* CSample::Create( void )
{

	// Create Class Instance
	CSample* pObject;
	pObject = new CSample;

	return pObject;

}

// CSample Initialize
void CSample::Init( void )
{

	// Initialize Process
	pMesh = Mesh3DObjectDX9::Create( ); 
	if( pMesh->Load( "data\\model\\m1_abrams\\m1abrams_all_s.x" ) ){
		renderer = MeshRenderer3D::SetComponent( &pMesh, &world );
	}
	TextureManager::SearchLoadDirectory( );


}

// CSample Uninitialize
void CSample::Uninit( void )
{

	// Uninitialize Process
	pMesh->Release( ); 
	SAFE_DELETE(pMesh)

}

// CSample Update
void CSample::Update( void )
{

	// Update Process
	world.Identity( );

	if( CInputKeyboard::Access()->GetKeyPress( DIK_W )){
		pos.z +=0.1f;
	}
	if( CInputKeyboard::Access()->GetKeyPress( DIK_S )){
		pos.z -=0.1f;
	}
	if( CInputKeyboard::Access()->GetKeyPress( DIK_A )){
		pos.x -=0.1f;
	}
	if( CInputKeyboard::Access()->GetKeyPress( DIK_D )){
		pos.x +=0.1f;
	}

	//CConsole::DebugLog(" playerPos : %f %f %f \n", pos.x, pos.y, pos.z );

	CDebugFont::Access()->SetRenderData( R_RENDER," playerPos : %f %f %f \n", pos.x, pos.y, pos.z  );

	world.Scaling( Vector3( 1, 1, 1 ));
	world.Rotate( Vector3( 0, D3DX_PI, 0 ));
	world.Transform( Vector3( pos.x, pos.y, pos.z ) );

}

// CSample Draw
void CSample::Draw( void )
{

	// Draw Process
	renderer->Render( );

}



Vector3& CSample::Getpos( void )
{
	return pos;
}


void CSample::Setpos( const Vector3& pos )
{

	CSample::pos = pos;

}


