/***************************************************************/
//
//
//		DirectX	[ sample.h ]
//
//											Author	kazuki tanaka
//											Date	2017 5/25
/*---------------------------------------------------------------
Update : 2017/5/25
			Create Header File -> sample.h.h 
 			< Add Class Function >
				CSAMPLE->Constructor
				CSAMPLE->Destructor
				CSAMPLE->Create ( static member )
				CSAMPLE->Init
				CSAMPLE->Uninit
				CSAMPLE->Update
				CSAMPLE->Draw

Update : 2017/5/25



/*-------------------------------------------------------------*/
#ifndef _SAMPLE_H_

#define _SAMPLE_H_



#include "system_component.h"

class RenderInterface;
class Mesh3DObject;


/*---------------------------------------------------------------
	Class
---------------------------------------------------------------*/


// Class CSample Using Sample
class CSample
{
public:

	CSample( );							// CSample Constructor
	~CSample( );						// CSample Destructor

	static CSample* Create( void );		// CSample Create Instance Class

	void Init( void );					// CSample Initialize
	void Uninit( void );				// CSample Uninitialize
	void Update( void );				// CSample Update
	void Draw( void );					// CSample Draw

	Vector3& Getpos( void );
	void Setpos( const Vector3& pos );

private:

	// Member Variable
	RenderInterface* renderer;
	Mesh3DObject*    pMesh;

	Vector3 pos;
	Matrix  world;

};


#endif	//	_SAMPLE_H_


