/***************************************************************/
//
//
//		DirectX	[ system_component.h ]
//
//											Author	kazuki tanaka
//											Date	2017 5/15
/*---------------------------------------------------------------
Update : 2017/5/15
			Create Header File -> systemcomponent.h 



/*-------------------------------------------------------------*/
#ifndef _SYSTEMCOMPONENT_H_

#define _SYSTEMCOMPONENT_H_



/*---------------------------------------------------------------
	Include File
---------------------------------------------------------------*/

#include "vector2.h"
#include "vector3.h"
#include "matrix.h"
#include "color.h"
#include "vertex2d.h"
#include "vertex3d.h"
#include "mesh3dobject.h"
#include "render_interface.h"

#include "texture_interface.h"
#include "texture_manager.h"

#include "vertexbuffer.h"
#include "vertexbuffer_manager.h"
#include "indexbuffer.h"

#include "event.h"

#include "d_manager.h"
#include "d_console.h"
#include "d_font.h"
#include "d_log.h"

/*---------------------------------------------------------------
	Macro Difinition
---------------------------------------------------------------*/

#ifndef SAFE_DELETE
#define SAFE_DELETE(p)       { if (p) { delete (p);     (p)=nullptr; } }
#endif

#ifndef SAFE_DELETE_ARRAY
#define SAFE_DELETE_ARRAY(p) { if (p) { delete[] (p);   (p)=nullptr; } }
#endif



#endif	//	_SYSTEMCOMPONENT_H_


