/***************************************************************/
//
//
//		DirectX	[ vertex3d.h ]
//
//											Author	kazuki tanaka
//											Date	2017 5/18
/*---------------------------------------------------------------
Update : 2017/5/18
			Create Header File -> vertex3d.h.h 
 			< Add Class Function >
				CVERTEX3D->Constructor
				CVERTEX3D->Destructor
				CVERTEX3D->Create ( static member )
				CVERTEX3D->Init
				CVERTEX3D->Uninit
				CVERTEX3D->Update
				CVERTEX3D->Draw

Update : 2017/5/18



/*-------------------------------------------------------------*/
#ifndef _VERTEX3D_H_

#define _VERTEX3D_H_

/*---------------------------------------------------------------
	Include File
---------------------------------------------------------------*/

#include "vector3.h"
#include "vector2.h"
#include "color.h"

/*---------------------------------------------------------------
	Macro Difinition
---------------------------------------------------------------*/

#define FVF_VERTEX_3D ( D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_NORMAL | D3DFVF_TEX1 )

/*---------------------------------------------------------------
	Class
---------------------------------------------------------------*/


// class Vertex3D Using Vertex3D
class Vertex3D
{
public:
	
	// Member Variable
	Vector3 pos;
	Vector3 nor;
	unsigned long color;
	Vector2 tex;
	
public:
	
	Vertex3D( );						// Vertex3D constructor
	~Vertex3D( );						// Vertex3D destructor
	
	Vertex3D( 							// Vertex3D constructor
		const Vector3& pos,
		const Vector3& nor,
		const Color& color,
		const Vector2& tex );

};


#endif	//	_VERTEX3D_H_


