/***************************************************************/
//
//
//		DirectX	[ virtual.cpp ]
//
//											Author	kazuki tanaka
//											Date	2017 5/25
/*---------------------------------------------------------------
Update : 2017/5/25
			virtual.cpp̍쐬

/*---------------------------------------------------------------
	Include File
---------------------------------------------------------------*/



#include "virtual.h"

#include "light.h"
#include "photo.h"

#include "sample.h"
#include "meshfield.h"

#include "rendering_orderdx9.h"

/*---------------------------------------------------------------
	Macro Difinition
---------------------------------------------------------------*/


/*---------------------------------------------------------------
	Const Number Difinition
---------------------------------------------------------------*/


/*----------------------------------------------------------------
	static member variable Initialize 
----------------------------------------------------------------*/





// CVirtual Constructor
CVirtual::CVirtual( )
	: pObj(nullptr)
	, meshField( nullptr )
{

	// Member Clear Process


}

// CVirtual Destructor
CVirtual::~CVirtual( )
{

	// Do Nothing!!

}

// CVirtual Create Instance 
CVirtual* CVirtual::Create( void )
{

	// Create Class Instance
	CVirtual* pObject;
	pObject = new CVirtual;

	return pObject;

}

// CVirtual Initialize
void CVirtual::Init( void )
{

	// Initialize Process
	meshField = MeshField::Create( );
	meshField->Init( );

	pObj = CSample::Create( );
	pObj->Init( );

	RenderingOrderDX9::Create( );

	CPhoto::Create( "mainCamera" )->Init( );
	CLight::Create( "Directional" );

}

// CVirtual Uninitialize
void CVirtual::Uninit( void )
{

	// Uninitialize Process
	meshField->Uninit( );
	pObj->Uninit( );

	CPhoto::ReleaseAll( );
	CLight::ReleaseAll( );


}

// CVirtual Update
void CVirtual::Update( void )
{

	// Update Process
	meshField->Update( );

	pObj->Update( );

	Vector3 pos = pObj->Getpos( );
	pos.y = meshField->GetHeight( pos );
	pObj->Setpos( pos );

}

// CVirtual Draw
void CVirtual::Draw( void )
{

	// Draw Process
	CPhoto::Access( "mainCamera" )->SetPhoto( );

	meshField->Draw( );
	pObj->Draw( );

}





